#include "elf.h"

#include "../constants.h"

elf::elf(RNG *rng, const feature enabled_features, const position &pos,
         const int gen_room_num):
        enemy_base{rng, enabled_features, relf, pos, gen_room_num, "E"} {}

void elf::print(output *out) {
        out->print_char(pos, 'E', COLOR_PAIR(COLOR_RED));
}

const char *elf::get_race_name() const {
        return "Elf";
}

long_result elf::attack(character *ch) {
        auto res1 = ch->get_hit(this, ATK, base_hit_rate);

        if (res1.res == result::died)
                return res1;

        auto res2 = ch->get_hit(this, ATK, base_hit_rate);

        if (res1.res == miss && res2.res == miss)
                return {miss, res1.msg + res2.msg};
        else if (res2.res == died)
                return {died, res1.msg + res2.msg};
        else
                return {hit, res1.msg + res2.msg};
}
