#include "pc.h"

#include "constants.h"
#include "player/goblin.h"
#include "player/drow.h"
#include "player/shade.h"
#include "player/troll.h"
#include "player/vampire.h"
#include "player/t_800.h"

void init_player(RNG *rng, std::unique_ptr<player_base> &pc,
                 const feature enabled_features, const enum race &r) {
        using std::make_unique;

        pc = nullptr;

        switch (r) {
        case rgoblin:
                pc = make_unique<goblin>(rng, enabled_features);
                break;

        case rdrow:
                pc = make_unique<drow>(rng, enabled_features);
                break;

        case rshade:
                pc = make_unique<shade>(rng, enabled_features);
                break;

        case rtroll:
                pc = make_unique<troll>(rng, enabled_features);
                break;

        case rvampire:
                pc = make_unique<vampire>(rng, enabled_features);
                break;

        case rt_800:
                pc = make_unique<t_800>(rng, enabled_features);
                break;

        default:
                break;
        }
}
